unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FatExpression;

type
  TForm1 = class(TForm)
    InputEdit: TEdit;
    Button1: TButton;
    LogList: TListBox;
    FatExpression1: TFatExpression;
    FuncList: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure FatExpression1Evaluate(Sender: TObject; Eval: String;
      Args: array of Double; ArgCount: Integer; var Value: Double);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure Log(const Msg: String);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  FatExpression1.Functions.Assign(FuncList.Lines);
  FatExpression1.Text := InputEdit.Text;
  Log('result=' + FloatToStr(FatExpression1.Value));
end;

procedure TForm1.Log(const Msg: String);
begin
  LogList.Items.Add(Msg);
  LogList.TopIndex := LogList.Items.Count - 1;
  LogList.ItemIndex := LogList.Items.Count - 1;
end;

procedure TForm1.FatExpression1Evaluate(Sender: TObject; Eval: String;
  Args: array of Double; ArgCount: Integer; var Value: Double);
var S: String;
  I: Integer;
begin
  // this code is used only to display some information
  S := '';
  if ArgCount > 0 then begin
    for I := 0 to ArgCount - 1 do
      S := S + ' ' + FloatToStr(Args[I]);
    Delete(S, 1, 1);
  end;

  Log(Format('eval %s (%d) [ %s ]', [Eval, ArgCount, S]));

  // here we handle the "Pi" function
  if UpperCase(Eval) = 'PI' then Value := Pi else
  // here we handle the "Pi" function, whichs adds together any number of parameters
  if UpperCase(Eval) = 'ADD' then begin
    for I := 0 to ArgCount - 1 do
      Value := Value + Args[I];
  end;
end;

end.


